gtkmm: Gtk::ColumnViewSorter Class Reference

gtkmm 4.12.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::ColumnViewSorter Class Reference
ListView Classes

A sorter implementation that is geared towards the needs of Gtk::ColumnView. More...

`#include <gtkmm/columnviewsorter.h>`

Inheritance diagram for Gtk::ColumnViewSorter:
[legend]

## Public Member Functions
| ColumnViewSorter (ColumnViewSorter && src) noexcept
ColumnViewSorter & | operator= (ColumnViewSorter && src) noexcept
| ~ColumnViewSorter () noexcept override
GtkColumnViewSorter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkColumnViewSorter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkColumnViewSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< ColumnViewColumn > | get_primary_sort_column ()
| Returns the primary sort column. More...
Glib::RefPtr< const ColumnViewColumn > | get_primary_sort_column () const
| Returns the primary sort column. More...
SortType | get_primary_sort_order () const
| Returns the primary sort order. More...
unsigned int | get_n_sort_columns () const
| Returns the number of columns by which the sorter sorts. More...
std::pair< Glib::RefPtr< ColumnViewColumn >, SortType > | get_nth_sort_column (unsigned int position)
| Gets the position'th sort column and its associated sort order. More...
std::pair< Glib::RefPtr< const ColumnViewColumn >, SortType > | get_nth_sort_column (unsigned int position) const
| See the non-const get_nth_sort_column(). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ColumnViewColumn > > | property_primary_sort_column () const
| The primary sort column. More...
Glib::PropertyProxy_ReadOnly< SortType > | property_primary_sort_order () const
| The primary sort order. More...
Public Member Functions inherited from Gtk::Sorter
| Sorter (Sorter && src) noexcept
Sorter & | operator= (Sorter && src) noexcept
| ~Sorter () noexcept override
GtkSorter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkSorter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Ordering | compare (gpointer item1, gpointer item2)
| Compares two given items according to the sort order implemented by the sorter. More...
Order | get_order () const
| Gets the order that self conforms to. More...
void | changed (Change change)
| Notifies all users of the sorter that it has changed. More...
Glib::SignalProxy< void(Change)> | signal_changed ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Sorter
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| ColumnViewSorter ()
Protected Member Functions inherited from Gtk::Sorter
| Sorter ()
virtual Ordering | compare_vfunc (gpointer item1, gpointer item2)
virtual Order | get_order_vfunc ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::ColumnViewSorter > | wrap (GtkColumnViewSorter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Sorter
Glib::RefPtr< Gtk::Sorter > | wrap (GtkSorter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Sorter
enum class | Order { Order::PARTIAL , Order::NONE , Order::TOTAL }
| Describes the type of order that a `Gtk::Sorter` may produce. More...
enum class | Change { Change::DIFFERENT , Change::INVERTED , Change::LESS_STRICT , Change::MORE_STRICT }
| Describes changes in a sorter in more detail and allows users to optimize resorting. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A sorter implementation that is geared towards the needs of Gtk::ColumnView.

The sorter returned by Gtk::ColumnView::get_sorter() is a Gtk::ColumnViewSorter.

In column views, sorting can be configured by associating sorters with columns, and users can invert sort order by clicking on column headers. The API of Gtk::ColumnViewSorter is designed to allow saving and restoring this configuration.

If you are only interested in the primary sort column (i.e. the column where a sort indicator is shown in the header), then you can just look at property_primary_sort_column() and property_primary_sort_order().

If you want to store the full sort configuration, including secondary sort columns that are used for tie breaking, then you can use get_nth_sort_column(). To get notified about changes, use Gtk::Sorter::signal_changed().

To restore a saved sort configuration on a Gtk::ColumnView, use code like:

auto sorter = column_view->get_sorter();
auto column_view_sorter = std::dynamic_pointer_cast<Gtk::ColumnViewSorter>(sorter);
if (column_view_sorter)
{
for (unsigned int i = column_view_sorter->get_n_sort_columns(); i > 0; --i)
{
auto [column, sort_order] = column_view_sorter->get_nth_sort_column(i-1);
column_view->sort_by_column(column, sort_order);
}
}

Since gtkmm 4.10:

## Constructor & Destructor Documentation

## ◆ ColumnViewSorter() [1/2]

Gtk::ColumnViewSorter::ColumnViewSorter | ( | ColumnViewSorter && | src | ) |
| noexcept

## ◆ ~ColumnViewSorter()

Gtk::ColumnViewSorter::~ColumnViewSorter | ( |  | ) |
| overridenoexcept

## ◆ ColumnViewSorter() [2/2]

Gtk::ColumnViewSorter::ColumnViewSorter | ( |  | ) |
| protected

## Member Function Documentation

## ◆ get_n_sort_columns()

unsigned int Gtk::ColumnViewSorter::get_n_sort_columns | ( |  | ) | const

Returns the number of columns by which the sorter sorts.

If the sorter of the primary sort column does not determine a total order, then the secondary sorters are consulted to break the ties.

Use the Gtk::Sorter::signal_changed() signal to get notified when the number of sort columns changes.

Since gtkmm 4.10:

Returns
  The number of sort columns.

## ◆ get_nth_sort_column() [1/2]

std::pair< Glib::RefPtr< ColumnViewColumn >, SortType > Gtk::ColumnViewSorter::get_nth_sort_column | ( | unsigned int | position | ) |

Gets the position'th sort column and its associated sort order.

Use the Gtk::Sorter::signal_changed() signal to get notified when sort columns change.

Since gtkmm 4.10:

Parameters

  position | The position of the sort column to retrieve (0 for the primary sort column).

Returns
  {sort_column, sort_order} The position's sort column and sort order.

## ◆ get_nth_sort_column() [2/2]

std::pair< Glib::RefPtr< const ColumnViewColumn >, SortType > Gtk::ColumnViewSorter::get_nth_sort_column | ( | unsigned int | position | ) | const

See the non-const get_nth_sort_column().

## ◆ get_primary_sort_column() [1/2]

Glib::RefPtr< ColumnViewColumn > Gtk::ColumnViewSorter::get_primary_sort_column | ( |  | ) |

Returns the primary sort column.

The primary sort column is the one that displays the triangle in a column view header.

Since gtkmm 4.10:

Returns
  The primary sort column.

## ◆ get_primary_sort_column() [2/2]

Glib::RefPtr< const ColumnViewColumn > Gtk::ColumnViewSorter::get_primary_sort_column | ( |  | ) | const

Returns the primary sort column.

The primary sort column is the one that displays the triangle in a column view header.

Since gtkmm 4.10:

Returns
  The primary sort column.

## ◆ get_primary_sort_order()

SortType Gtk::ColumnViewSorter::get_primary_sort_order | ( |  | ) | const

Returns the primary sort order.

The primary sort order determines whether the triangle displayed in the column view header of the primary sort column points upwards or downwards.

If there is no primary sort column, then this function returns `Gtk::SortType::ASCENDING`.

Since gtkmm 4.10:

Returns
  The primary sort order.

## ◆ get_type()

static GType Gtk::ColumnViewSorter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkColumnViewSorter * Gtk::ColumnViewSorter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkColumnViewSorter * Gtk::ColumnViewSorter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkColumnViewSorter * Gtk::ColumnViewSorter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

ColumnViewSorter & Gtk::ColumnViewSorter::operator= | ( | ColumnViewSorter && | src | ) |
| noexcept

## ◆ property_primary_sort_column()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ColumnViewColumn > > Gtk::ColumnViewSorter::property_primary_sort_column | ( |  | ) | const

The primary sort column.

The primary sort column is the one that displays the triangle in a column view header.

Since gtkmm 4.10:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_primary_sort_order()

Glib::PropertyProxy_ReadOnly< SortType > Gtk::ColumnViewSorter::property_primary_sort_order | ( |  | ) | const

The primary sort order.

The primary sort order determines whether the triangle displayed in the column view header of the primary sort column points upwards or downwards.

Since gtkmm 4.10:

Default value: Gtk::SortType::ASCENDING

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::ColumnViewSorter > wrap | ( | GtkColumnViewSorter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.